import initCtx from "@/utils/ctx.js";
import * as echarts from "echarts";

export default function () {
	const {utils} = initCtx(this)
	utils.setEcharts(echarts)

	this.$delay(function () {
		let that = this

		this.reloadRequestsChart("daily-requests-chart", "请求数统计", this.dailyStats, function (args) {
			if (args.seriesIndex == 0) {
				return that.dailyStats[args.dataIndex].day + "<br/>请求数：" + utils.formatNumber(that.dailyStats[args.dataIndex].countRequests)
			}
			if (args.seriesIndex == 1) {
				let ratio = 0
				if (that.dailyStats[args.dataIndex].countRequests > 0) {
					ratio = Math.round(that.dailyStats[args.dataIndex].countCachedRequests * 10000 / that.dailyStats[args.dataIndex].countRequests) / 100
				}
				return that.dailyStats[args.dataIndex].day + "<br/>缓存请求数：" + utils.formatNumber(that.dailyStats[args.dataIndex].countCachedRequests) + "<br/>缓存命中率：" + ratio + "%"
			}
			return ""
		})
		this.reloadTrafficChart("daily-traffic-chart", "流量统计", this.dailyStats, function (args) {
			if (args.seriesIndex == 0) {
				return that.dailyStats[args.dataIndex].day + "<br/>流量：" + utils.formatBytes(that.dailyStats[args.dataIndex].bytes)
			}
			if (args.seriesIndex == 1) {
				let ratio = 0
				if (that.dailyStats[args.dataIndex].bytes > 0) {
					ratio = Math.round(that.dailyStats[args.dataIndex].cachedBytes * 10000 / that.dailyStats[args.dataIndex].bytes) / 100
				}
				return that.dailyStats[args.dataIndex].day + "<br/>缓存流量：" + utils.formatBytes(that.dailyStats[args.dataIndex].cachedBytes) + "<br/>缓存命中率：" + ratio + "%"
			}
			return ""
		})
	})

	this.reloadRequestsChart = function (chartId, name, stats, tooltipFunc) {
		let chartBox = document.getElementById(chartId)
		if (chartBox == null) {
			return
		}

		let axis = utils.countAxis(stats, function (v) {
			return Math.max(v.countRequests, v.countCachedRequests)
		})

		const hasCachedData = stats.$any(function (k, stat) {
			return stat.countCachedRequests > 0
		})

		utils.initChart(chartBox, undefined, chart => {
			let option = {
				xAxis: {
					data: stats.map(function (v) {
						return v.day.substr(5)
					}),
					axisLabel: {
						color: utils.chartLabelColor
					}
				},
				yAxis: {
					axisLabel: {
						formatter: function (value) {
							return value + axis.unit
						},
						color: utils.chartLabelColor
					}
				},
				tooltip: {
					show: true,
					trigger: "item",
					formatter: tooltipFunc
				},
				grid: {
					left: 50,
					top: 40,
					right: 20,
					bottom: 20
				},
				series: [
					{
						name: "请求数",
						type: "line",
						data: stats.map(function (v) {
							return v.countRequests / axis.divider
						}),
						itemStyle: {
							color: utils.DefaultChartColor
						},
						areaStyle: {
							color: utils.DefaultChartColor
						},
						smooth: true
					},
					{
						name: "缓存请求数",
						type: "line",
						data: stats.map(function (v) {
							if (!v.countCachedRequests) {
								return null
							}
							return v.countCachedRequests / axis.divider
						}),
						itemStyle: {
							color: utils.CacheChartColor
						},
						areaStyle: {
							color: utils.CacheChartColor
						},
						smooth: true
					}
				],
				legend: {
					data: ['请求数', '缓存请求数'],
					textStyle: {
						color: utils.chartLabelColor()
					}
				},
				animation: true
			}
			chart.setOption(option)
			chart.resize()
		})
	}

	this.reloadTrafficChart = function (chartId, name, stats, tooltipFunc) {
		let chartBox = document.getElementById(chartId)
		if (chartBox == null) {
			return
		}

		let axis = utils.bytesAxis(stats, function (v) {
			return Math.max(v.bytes, v.cachedBytes)
		})

		const hasCachedData = stats.$any(function (k, stat) {
			return stat.cachedBytes > 0
		})

		utils.initChart(chartBox, undefined, chart => {
			let option = {
				xAxis: {
					data: stats.map(function (v) {
						return v.day.substr(5)
					}),
					axisLabel: {
						color: utils.chartLabelColor
					}
				},
				yAxis: {
					axisLabel: {
						formatter: function (value) {
							return value + axis.unit
						},
						color: utils.chartLabelColor
					}
				},
				tooltip: {
					show: true,
					trigger: "item",
					formatter: tooltipFunc
				},
				grid: {
					left: 50,
					top: 40,
					right: 20,
					bottom: 20
				},
				series: [
					{
						name: "流量",
						type: "line",
						data: stats.map(function (v) {
							return v.bytes / axis.divider
						}),
						itemStyle: {
							color: utils.DefaultChartColor
						},
						areaStyle: {
							color: utils.DefaultChartColor
						},
						smooth: true
					},
					{
						name: "缓存流量",
						type: "line",
						data: stats.map(function (v) {
							if (!hasCachedData) {
								return null
							}
							return v.cachedBytes / axis.divider
						}),
						itemStyle: {
							color: utils.CacheChartColor
						},
						areaStyle: {
							color: utils.CacheChartColor
						},
						smooth: true
					}
				],
				legend: {
					data: ['流量', '缓存流量'],
					textStyle: {
						color: utils.chartLabelColor()
					}
				},
				animation: true
			}
			chart.setOption(option)
			chart.resize()
		})
	}
}
